-----------------------------------------------------------------------
-- Locale
-----------------------------------------------------------------------
local L = AceLibrary("AceLocale-2.2"):new("Violation: Healing")

L:RegisterTranslations("enUS", function() return {
	["Healing done"] = true,
	["H"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Healing done"] = "치유량",
} end)

-----------------------------------------------------------------------
-- Locals
-----------------------------------------------------------------------

local playerName = nil

local event = {
	eventType = "Heal",
	sourceID_ne = false,
}

local data = nil
local dirty = 0
local moduleName = "Healing"

-----------------------------------------------------------------------
-- Module declaration
-----------------------------------------------------------------------

local mod = Violation:NewModule(moduleName, "Parser-3.0")
mod.revision = tonumber(("$Revision: 34821 $"):sub(12, -3)) or 1
mod.version = 3

-----------------------------------------------------------------------
-- Module initialization
-----------------------------------------------------------------------

function mod:OnModuleRegister()
	playerName = UnitName("player")
end

function mod:OnModuleEnable()
	self:RegisterParserEvent(event, "OnParserEvent")
end

function mod:OnReset()
	if type(data) == "table" then
		data = self:del(data)
	end
	data = self:new()
	data[playerName] = 0
	dirty = 0
end

-----------------------------------------------------------------------
-- Module implementation
-----------------------------------------------------------------------

function mod:GetRevision() return self.revision end
function mod:GetDisplayName() return L["Healing done"] end
function mod:GetShortDisplayName() return L["H"] end
function mod:GetBroadcastData()
	local x = dirty
	dirty = 0
	return x
end

function mod:IsDirty()
	return dirty > 0 and true or false
end

function mod:OnRemoteData(sender, input)
	data[sender] = (data[sender] or 0) + input
end

function mod:OnParserEvent(event)
	if event.amount and event.sourceName then
		if event.sourceID == "player" then 
			data[playerName] = data[playerName] + event.amount
			dirty = dirty + event.amount
		elseif not Violation:UserViolation(event.sourceName, moduleName) then
			self:OnRemoteData( event.sourceName, event.amount )
		end
	end
end

function mod:GetData(player)
	if player then
		return data[player]
	else
		return data
	end
end

